#include "Alert.h"
#include "OpenGL.h"

void Alert::Initialize(const Color& color, const Vec2& origin, float speed, float life)
{
    m_color     = color;
    m_origin    = origin;
    m_speed     = speed;
    m_life      = 0.0f;
    m_maxLife   = life;
}

void Alert::Render(const Planet& planet) const
{

    glColor4f(m_color.r, m_color.g, m_color.b, 1.0f - m_life / m_maxLife);
    glLineWidth(5.0f);

    float radius = m_life * m_speed;
    DrawCircle(m_origin, radius, 32);

}

void Alert::Update(Planet& planet, float deltaTime)
{
    m_life += deltaTime;
}

bool Alert::GetIsAlive() const
{
    return m_life < m_maxLife;
}