#ifndef ALERT_H
#define ALERT_H

#include "Effect.h"
#include "Color.h"
#include "Vec2.h"

class Alert : public Effect
{

public:

    void Initialize(const Color& color, const Vec2& origin, float speed, float life);

    virtual void Render(const Planet& planet) const;
    virtual void Update(Planet& planet, float deltaTime);

    virtual bool GetIsAlive() const;

private:

    float               m_maxLife;
    float               m_life;
    Color               m_color;
    float               m_speed;
    Vec2                m_origin;

};

#endif