#ifndef DUDE_H
#define DUDE_H

#include "Direction.h"
#include "Color.h"
#include "Thing.h"

//
// Forward declarations.
//

class Planet;

/**
 * Inhabitant of the planet.
 */
class Dude : public Thing
{

public:

    Dude();

    virtual void    Update(Planet& planet, float deltaTime);
    virtual void    Render(const Planet& planet, float time) const;

    bool            GetIsAlive() const;

    void            RandomizeDirection();

    void            SwitchDirection();

    void            SetHue(float hue);
    float           GetHue() const;

    void            SetCooperation(float cooperation);
    float           GetCooperation() const;

    void            SetFaction(unsigned int faction);
    unsigned int    GetFaction() const;

    void            SetKnowledge(float knowledge);
    float           GetKnowledge() const;

    void            Kill(Planet& planet);

    Color           GetColor() const;

    bool            GetIsGenius() const;
    void            SetIsGenius(bool genius);

    float           GetLumber() const;
    void            SetLumber(float lumber);

    float           GetOre() const;
    void            SetOre(float ore);

private:

    enum State
    {
        State_Moving,
        State_Turning,
    };

    bool            m_alive;

    float           m_moveSpeed;

    Direction       m_direction;

    float           m_lastTurnTime;

    State           m_state;

    float           m_hue;
    float           m_cooperation;
    unsigned int    m_faction;
    float           m_knowledge;

    bool            m_genius;

    float           m_lumber;
    float           m_ore;

};

#endif