#include "Log.h"

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

Log* Log::s_instance = NULL;

Log& Log::Get()
{
    if (s_instance == NULL)
    {
        s_instance = new Log;
    }
    return *s_instance;
}

Log::Log()
{

    m_font.Initialize(L"Arial");

    for (int i = 0; i < s_maxLines; ++i)
    {
        m_text[i][0] = 0;
    }

    m_currentLine = 0;

}

void Log::Print(const char* fmt, ...)
{

	va_list	ap;

	va_start(ap, fmt);
    vsprintf_s(m_text[m_currentLine], s_maxLineLength, fmt, ap);
	va_end(ap);

    m_currentLine = (m_currentLine + 1) % s_maxLines;

}

void Log::Render() const
{

    for (int i = 0; i < s_maxLines; ++i)
    {
     
        int y = (m_currentLine - i + s_maxLines) % s_maxLines;
        
        glColor3f(0.0f, 0.0f, 0.0f);
        glRasterPos2f(20, 20 + y * 15);
        m_font.Print(m_text[i]);

    }
   

}
