#include "Math.h"
#include <stdlib.h>

const float pi = 3.1415926535f;

float Bump(float x)
{
    return (cosf(x * pi) + 1.0f) * 0.5f;
}

int Wrap(int x, int min, int max)
{
 
    const int range = max - min;

    if (x < min)
    {
        x += ((max - x) / range) * range;
    }    

    if (x >= max)
    {
        x -= ((x - min) / range) * range;
    }
    
    return x;

}

float Wrap(float x, float min, float max)
{
 
    const float range = max - min;

    if (x < min)
    {
        x += floorf((max - x) / range) * range;
    }    

    if (x >= max)
    {
        x -= floorf(((x - min) / range)) * range;
    }
    
    return x;

}

float Clamp(float x, float min, float max)
{
    if (x < min)
    {
        return min;
    }
    else if (x > max)
    {
        return max;
    }
    else
    {
        return x;
    }
}

float Random(float min, float max)
{
    return (rand() * (max - min)) / RAND_MAX + min;
}

float Lerp(float a, float b, float t)
{
    return a + (b - a) * t;
}

float Sqr(float x)
{
    return x * x;
}

float Interpolate(float value, float target, float speed)
{
    
    if (value < target)
    {
        value += speed;
        if (value > target)
        {
            value = target;
        }
    }
    else
    {
        value -= speed;
        if (value < target)
        {
            value = target;
        }
    }

    return value;

}

float GetDegrees(float radians)
{
    return radians * 180.0f / pi;
}
