#ifndef MATH_H
#define MATH_H

#include <math.h>

extern const float pi;

float   Bump(float x);

int     Wrap(int x, int min, int max);
float   Wrap(float x, float min, float max);

float   Clamp(float x, float min, float max);

float   Random(float min, float max);

float   Lerp(float a, float b, float t);

float   Sqr(float x);

float   Interpolate(float value, float target, float speed);

template <class T>
void Swap(T& a, T& b)
{
    T t = a;
    a = b;
    b = t;
}

float GetDegrees(float radians);

#endif