#include "Meteorite.h"
#include "OpenGL.h"
#include "ParticleSystem.h"
#include "Planet.h"

Meteorite::Meteorite()
{
    m_alive = true;
}

void Meteorite::Update(Planet& planet, float deltaTime)
{
        
    if (planet.GetIsUnderwater(m_x))
    {
        Kill(planet);
    }

}
    
void Meteorite::Render(const Planet& planet, float time) const
{
    
    // Use the depth test so that we don't write the same alpha blended surface twice.
    glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LESS);

    glColor4f(00.0f, 0.0f, 0.0f, 0.5f);
    DrawFilledCircle(Vec2(0.0f, 0.0f), 15.0f, 32);

    glDisable(GL_DEPTH_TEST);

}

bool Meteorite::GetIsAlive() const
{
    return m_alive;
}

void Meteorite::Kill(Planet& planet)
{

    m_alive = false;

    const float height = 20.0f;
    const float radius = 6.0f;

    ParticleSystem* effect = new ParticleSystem;
    effect->InitializeCircle(Color(0.0f, 0.0f, 0.0f), planet.GetPoint(m_x, height), radius, 0.1f, 1000.0f);

    planet.AddEffect(effect);

}
