#ifndef PARTICLE_SYSTEM_H
#define PARTICLE_SYSTEM_H

#include "Effect.h"
#include "Color.h"
#include "Vec2.h"

class ParticleSystem : public Effect
{

public:

    void InitializeCircle(const Color& color, const Vec2& origin, float radius, float speed, float life, int numParticles = 25);

    virtual void Render(const Planet& planet) const;
    virtual void Update(Planet& planet, float deltaTime);

    virtual bool GetIsAlive() const;

private:

    struct Particle
    {
        Vec2    position;
        Vec2    velocity;
        float   life;
    };

    static const int    s_maxParticles = 200;

    float               m_maxLife;
    Color               m_color;
    Particle            m_particle[s_maxParticles];
    int                 m_numParticles;

};

#endif