#ifndef PLANT_H
#define PLANT_H

#include "Thing.h"

//
// Forward declarations
//

class Planet;

/**
 * Leafy green thing.
 */
class Plant : public Thing
{

public:

    Plant();

    void            Update(Planet& planet, float deltaTime);
    void            Render(const Planet& planet, float time) const;

    bool            GetIsAlive() const;

    void            Kill(Planet& planet);

private:

    enum State
    {
        State_Growing,
        State_Dying,
    };

    static const float      s_totalGrowTime;

    State                   m_state;

    float                   m_growTime;
    float                   m_scale;

    bool                    m_alive;

};

#endif
