#include "Timer.h"
#include <windows.h>

Timer::Timer()
{
    QueryPerformanceFrequency(&m_frequency);
    Reset();
    Update();
}

void Timer::Reset()
{
    QueryPerformanceCounter(&m_resetTime);
    m_lastTime = m_resetTime;
    m_currTime = m_resetTime;
}

void Timer::Update()
{
    m_lastTime = m_currTime;
    QueryPerformanceCounter(&m_currTime);
}

float Timer::GetElapsedTime() const
{
    LONGLONG elapsed = m_currTime.QuadPart - m_lastTime.QuadPart;
    return static_cast<float>((elapsed * 1000.0) / m_frequency.QuadPart);
}

float Timer::GetTotalElapsedTime() const
{
    LONGLONG elapsed = m_currTime.QuadPart - m_resetTime.QuadPart;
    return static_cast<float>((elapsed * 1000.0) / m_frequency.QuadPart);
}