#include "Vec2.h"
#include <math.h>

Vec2::Vec2()
{
}

Vec2::Vec2(float _x, float _y) : x(_x), y(_y)
{
}

float Vec2::GetLength() const
{
    return sqrtf(x * x + y * y);
}
    
Vec2 Vec2::GetUnit() const
{
    return *this / GetLength();
}

Vec2 operator+(const Vec2& v, const Vec2& w)
{
    return Vec2(v.x + w.x, v.y + w.y);
}

Vec2 operator-(const Vec2& v, const Vec2& w)
{
    return Vec2(v.x - w.x, v.y - w.y);
}

Vec2 operator*(const Vec2& v, float x)
{
    return Vec2(v.x * x , v.y * x);
}

Vec2 operator/(const Vec2& v, float x)
{
    return Vec2(v.x / x , v.y / x);
}